<%
	Option Explicit

	Class XDatabase
		Private mCnn
		Private mSQL
		Private mDebug
		Private mQuerySuccess
		Private mRecordsAffected

		Public Property Let Cnn(ByVal strCnn)
			mCnn = strCnn
		End Property

		Public Property Let SQL(ByVal strSQL)
			mSQL = strSQL
		End Property

		Public Property Let Debug(ByVal blnDebug)
			mDebug = blnDebug
		End Property

		Public Property Get Success()
			Success = mQuerySuccess
		End Property

		Public Property Get RecordsAffected()
			RecordsAffected = mRecordsAffected
		End Property

		Public Function ExecuteSQLQuery()
			mQuerySuccess = False
			mRecordsAffected = -1

			If mDebug Then
				Response.Write("<b>Called XDatabase.ExecuteSQLQuery():</b><br /><font face=""Wingdings""></font> ")
				Response.Write("<b>Cnn:</b> " & mCnn & "<br /><font face=""Wingdings""></font> ")
				Response.Write("<b>SQL:</b> " & mSQL & "<p />")
			End If

			Dim objCnn
			Set objCnn = Server.CreateObject("ADODB.Connection")
			objCnn.ConnectionString = mCnn
			objCnn.Open()
			Call objCnn.Execute(mSQL, mRecordsAffected, adExecuteNoRecords)
			objCnn.Close()
			Set objCnn = Nothing
			If InStr(UCASE(mSQL), "DELETE") = 1 OR InStr(UCASE(mSQL), "UPDATE") = 1 Then
				If mRecordsAffected > 0 Then
					mQuerySuccess = True
				End If
			ElseIf InStr(UCASE(mSQL), "INSERT INTO") = 1 Then
				If mRecordsAffected = 1 Then
					mQuerySuccess = True
				End If
			Else
				mQuerySuccess = True
			End If
		End Function

		Public Function GetDatabaseArray()
			If mDebug Then
				Response.Write("<b>Called XDatabase.GetDatabaseArray():</b><br /><font face=""Wingdings""></font> ")
				Response.Write("<b>Cnn:</b> " & mCnn  & "<br /><font face=""Wingdings""></font> ")
				Response.Write("<b>strSQL:</b> " & mSQL & "<p />")
			End If

			Dim objCnn, objRst
			Set objCnn = Server.CreateObject("ADODB.Connection")
			objCnn.ConnectionString = mCnn
			objCnn.Open()
			Set objRst = objCnn.Execute(mSQL)
			If objRst.BOF OR objRst.EOF Then
				objRst.Close()
				Set objRst = Nothing
				objCnn.Close()
				Set objCnn = Nothing
			Else
				GetDatabaseArray = objRst.GetRows()
				objRst.Close()
				Set objRst = Nothing
				objCnn.Close()
				Set objCnn = Nothing
			End If
		End Function
	End Class

	Sub AutoDropDowns(strCnn, strCompare, strValue, strText, strTable)
		Dim strSQL, arrRst
		strSQL = "SELECT " & strValue & ", " & strText & " FROM " & strTable & " ORDER BY " & strText & ";"

		If Application("Debug") Then
			Response.Write("<b>Called XDatabase.AutoDropDowns():</b><br /><font face=""Wingdings""></font> ")
			Response.Write("<b>Cnn:</b> " & strCnn  & "<br /><font face=""Wingdings""></font> ")
			Response.Write("<b>strSQL:</b> " & strSQL & "<p />")
		End If

		Dim objXDatabase
		Set objXDatabase = New XDatabase
		objXDatabase.Cnn = strCnn
		objXDatabase.SQL = strSQL
		arrRst = objXDatabase.GetDatabaseArray()
		Set objXDatabase = Nothing
		If IsArray(arrRst) Then
	         	Response.Write("<option value=""0"">---- Select an option ----</option>")

			Dim intRecord
			For intRecord = 0 To UBound(arrRst, 2)
				'Response.Write("If " & strCompare & " = " & arrRst(0, intRecord) & " Then")
				If strCompare = arrRst(0, intRecord) Then
					Response.Write("<option value=""" & arrRst(0, intRecord) & """ selected>" & arrRst(1, intRecord))
				Else
					Response.Write("<option value=""" & arrRst(0, intRecord) & """>" & arrRst(1, intRecord))
				End If
			Next
			Erase arrRst
		Else
			Response.Write("<option value=""0"" selected>---- No options ----</option>")
		End If
	End Sub

	Function Checked(strCompare, strValue)
		If Len(strCompare) > 0 AND CBool(strCompare) = CBool(strValue) Then
			Checked = " checked"
		End If
	End Function
%>